# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List
from pydantic.v1 import BaseModel, Field, conlist
from lusid.models.portfolio_entity_id import PortfolioEntityId

class GroupReconciliationDefinitionPortfolioEntityIds(BaseModel):
    """
    GroupReconciliationDefinitionPortfolioEntityIds
    """
    left: conlist(PortfolioEntityId, min_items=1) = Field(..., description="Portfolio Entity Id of the left side of a reconciliation")
    right: conlist(PortfolioEntityId, min_items=1) = Field(..., description="Portfolio Entity Id of the right side of a reconciliation")
    __properties = ["left", "right"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GroupReconciliationDefinitionPortfolioEntityIds:
        """Create an instance of GroupReconciliationDefinitionPortfolioEntityIds from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in left (list)
        _items = []
        if self.left:
            for _item in self.left:
                if _item:
                    _items.append(_item.to_dict())
            _dict['left'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in right (list)
        _items = []
        if self.right:
            for _item in self.right:
                if _item:
                    _items.append(_item.to_dict())
            _dict['right'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GroupReconciliationDefinitionPortfolioEntityIds:
        """Create an instance of GroupReconciliationDefinitionPortfolioEntityIds from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GroupReconciliationDefinitionPortfolioEntityIds.parse_obj(obj)

        _obj = GroupReconciliationDefinitionPortfolioEntityIds.parse_obj({
            "left": [PortfolioEntityId.from_dict(_item) for _item in obj.get("left")] if obj.get("left") is not None else None,
            "right": [PortfolioEntityId.from_dict(_item) for _item in obj.get("right")] if obj.get("right") is not None else None
        })
        return _obj
